=begin
(c) TIG 2011
conan(radius,angle,{segs})
or with NO arguments conan >> dialog
=end
require 'sketchup.rb'
###
class Conan
def Conan::make(radius=nil, angle=nil, segs=36)
  if not radius or not angle ### use dialog
    prompts=["Radius: ", "Angle: ", "Segments: "]
    values=[500.mm, 45.0, 36]
    title="Conan Parameters"
    results=UI.inputbox(prompts, values, title)
    return nil if not results
    radius, angle, segs = results
    radius=1 if radius <=0
    angle=45.0 if angle <=0
    angle=45.0 if angle >=90
    segs=3 if segs <3
  #else ### we use arguments
  end#if
  model=Sketchup.active_model
  ents=model.active_entities
  model.start_operation("New Conan")
  cone=ents.add_group()
  cents=cone.entities
  cents.add_cpoint(ORIGIN)
  ht=radius * Math::tan(angle.degrees)
  px=Geom::Point3d.new(0, 0, ht)
  pc=Geom::Point3d.new(radius, 0, 0)
  circ=cents.add_circle(ORIGIN, Z_AXIS, radius, segs)
  face=cents.add_face(ORIGIN, px, pc)
  face.followme(circ)
  base=nil
  cents.each{|e|
    if e.class==Sketchup::Face and e.normal.z.abs==1
      base=e
      break
    end#if
  }
  cents.to_a.each{|e|e.reverse! if e.class==Sketchup::Face} if base.normal.z==1
  cone.set_attribute("Conan","radius",radius)
  cone.set_attribute("Conan","angle",angle)
  cone.set_attribute("Conan","segs",segs)
  model.commit_operation
  return cone
end
def Conan::edit(cone=nil)
  model=Sketchup.active_model
  cone=Conan.check() if not cone
  if not cone or not cone.valid?
    UI.messagebox("Edit Conan Parameters:\nYou must Select a suitable Conan to Edit!")
    return nil
  end#if
  model.start_operation("Edit Conan Parameters")
  radius=cone.get_attribute("Conan","radius",nil)
  angle=cone.get_attribute("Conan","angle",nil)
  segs=cone.get_attribute("Conan","segs",nil)
  prompts=["Radius: ", "Angle: ", "Segments: "]
  values=[radius, angle, segs]
  title="Edit Conan Parameters"
  results=UI.inputbox(prompts, values, title)
  return nil if not results
  radius, angle, segs = results
  radius=1 if radius <=0
  angle=45.0 if angle <=0
  angle=45.0 if angle >=90
  segs=3 if segs <3
  tr=cone.transformation
  ncone=Conan.make(radius, angle, segs)
  ncone.transform!(tr)
  ncone.layer=cone.layer
  ncone.material=cone.material
  ncone.set_attribute("Conan","radius",radius)
  ncone.set_attribute("Conan","angle",angle)
  ncone.set_attribute("Conan","segs",segs)
  cone.erase!
  model.commit_operation
  return
end
def Conan.check()
  model=Sketchup.active_model
  ss=model.selection
  cone=nil
  ss.each{|e|
    r=e.get_attribute("Conan","radius",nil)
    a=e.get_attribute("Conan","angle",nil)
    s=e.get_attribute("Conan","segs",nil)
    if r and a and s
      cone=e
      break
    end#if
  }
  return cone
end

end#class
###
def conan(radius=nil, angle=nil, segs=36)
  Conan.make(radius=nil, angle=nil, segs=36)
end
### menu
if not file_loaded?(__FILE__)
    ### main_menu
    UI.menu("Draw").add_item("Conan"){Conan.make()}
    UI.menu("Draw").add_item("Edit Selected Conan"){Conan.edit()}
    ### context_menu
    cone=nil
    UI.add_context_menu_handler{|menu|menu.add_item("Edit Conan"){Conan.edit(cone)}}#if cone=Conan.check() # remove # if you can stand selection check delays
end#if
file_loaded(__FILE__)
###
